---
title: 'HTMLSlotElement: slotchange event'
slug: Web/API/HTMLSlotElement/slotchange_event
tags:
  - Event
  - Reference
  - Web Components
  - events
  - shadow dom
  - slotchange
---
<div>{{APIRef}}</div>

<p><span class="seoSummary">The <code><strong>slotchange</strong></code> event is fired on an {{DOMxRef("HTMLSlotElement")}} instance ({{HTMLElement("slot")}} element) when the node(s) contained in that slot change.</span></p>

<div class="note">
<p><strong>Note:</strong> the <code>slotchange</code> event doesn't fire if the children of a slotted node change — only if you change (e.g. add or delete) the actual nodes themselves.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>None</td>
  </tr>
 </tbody>
</table>

<p>In order to trigger a <strong>slotchange</strong> event, one has to set or remove the <code>slot </code>attribute.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">element.setAttribute('slot', slotName);
// element.assignedSlot = $slot
element.removeAttribute('slot');
// element.assignedSlot = null
</pre>

<p>The following snippet is taken from our <a href="https://github.com/mdn/web-components-examples/tree/master/slotchange">slotchange example</a> (<a href="https://mdn.github.io/web-components-examples/slotchange/">see it live also</a>).</p>

<pre class="brush: js notranslate">let slots = this.shadowRoot.querySelectorAll('slot');
slots[1].addEventListener('slotchange', function(e) {
  let nodes = slots[1].assignedNodes();
  console.log('Element in Slot "' + slots[1].name + '" changed to "' + nodes[0].outerHTML + '".');
});</pre>

<p>Here we grab references to all the <code>&lt;slot&gt;</code>s, then add a <code>slotchange</code> event listener to the template's second slot — which is the one which has its contents changed in the example.</p>

<p>Every time the element inserted in the slot changes, we log a report to the console saying which slot has changed, and what the new node inside the slot is.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#mutation-observers", '"Mutation observers" and slotchange event')}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLSlotElement.slotchange_event")}}</p>

<h2 id="See_also">See also</h2>

<p>{{domxref("HTMLSlotElement")}}</p>
